//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * メッシュジオメトリヘッダ
 * @author Junpee
 */

#ifndef MESH_GEOMETRY_H_
#define MESH_GEOMETRY_H_

namespace Lamp{

class IntersectionResult;

//------------------------------------------------------------------------------
/**
 * メッシュジオメトリ
 */
class MeshGeometry{
public:
	//--------------------------------------------------------------------------
	// 生成、破棄
	//--------------------------------------------------------------------------
	/**
	 * コンストラクタ
	 */
	MeshGeometry();

	/**
	 * コピーコンストラクタ
	 * @param copy コピー元
	 */
	explicit MeshGeometry(const MeshGeometry& copy);

	/**
	 * 代入コピー
	 * @param copy コピー元
	 * @return コピーされたメッシュジオメトリ
	 */
	virtual const MeshGeometry& operator =(const MeshGeometry& copy);

	/**
	 * デストラクタ
	 */
	virtual ~MeshGeometry();

	//--------------------------------------------------------------------------
	// 交差
	//--------------------------------------------------------------------------
	/**
	 * 球交差
	 * @param sphere 交差判定する球
	 * @return 交差していればtrue
	 */
	virtual bool intersect(const Sphere& sphere) const{
		Assert(false);
		return false;
	}

	/**
	 * 球交差
	 * @param sphere 交差判定する球
	 * @param result 交差結果
	 */
	virtual void intersect(
		IntersectionResult* result, const Sphere& sphere) const{
		Assert(false);
	}

	/**
	 * 球バウンディング交差
	 * @param sphere 交差判定する球
	 * @return バウンディングと交差していればtrue
	 */
	virtual bool intersectBounding(const Sphere& sphere) const{
		Assert(false);
		return false;
	}

	/**
	 * 球メッシュ交差
	 * @param sphere 交差判定する球
	 * @return メッシュと交差していればtrue
	 */
	virtual bool intersectMesh(const Sphere& sphere) const{
		Assert(false);
		return false;
	}

	/**
	 * 球メッシュ交差
	 * @param sphere 交差判定する球
	 * @param result 交差結果
	 */
	virtual void intersectMesh(
		IntersectionResult* result, const Sphere& sphere) const{
		Assert(false);
	}

};

//------------------------------------------------------------------------------
} // End of namespace Lamp
#endif // End of MESH_GEOMETRY_H_
//------------------------------------------------------------------------------
